<?php
if (!defined('PmWiki')) exit();

include_once("StaticPages.php");

# In StaticPages.php this is linked:  $LinkFunctions['<:page>'] = 'LinkToPossibleStaticPage';
function LinkFromPossibleStaticPage($pagename,$imap,$path,$title,$txt,$fmt=NULL) {
	
	global $LinkFunctionsIntercepted;
	
	$targetLink = $LinkFunctionsIntercepted[$imap]($pagename,$imap,$path,$title,$txt,$fmt);
	
	global $action, $StaticPageBrowseActionName;
	
	if ($action != $StaticPageBrowseActionName){
		return $targetLink;
	}
	
	global $ApplicationPathUrl, $StaticPageDirToWikiDir;
	
	$hrefLinkBase = 'href="' . $ApplicationPathUrl;
	if ( ($foundPosn = strpos($targetLink, $hrefLinkBase)) !== FALSE){
		$targetLink = substr_replace($targetLink, $StaticPageDirToWikiDir, $foundPosn, strlen($hrefLinkBase));
	}
	
	return $targetLink;
}

# In StaticPages.php this is linked:  $LinkFunctions['<:page>'] = 'LinkToPossibleStaticPage';
function LinkToPossibleStaticPage($pagename,$imap,$path,$title,$txt,$fmt=NULL) {
    
    global $StaticPageDir, $ApplicationPathUrl, $ApplicationPathDir;
    global $StaticPageBrowseActionName;
	global $action;
	
	$StaticPagePath = "./" . $StaticPageDir;
	
	if (isPossibleStaticPage($pagename)){
		if ($action == $StaticPageBrowseActionName){
			$isThisPageRepresentingAStaticPage = TRUE;
			$StaticPagePath = ".";
		}else{
			$isThisPageRepresentingAStaticPage = FALSE;
		}
	}else{
		if ($action = "browse"){
			# A Static Page
			@removeStaticPage($pagename, $ApplicationPathDir);
		}
	}
	
    $targetLink = LinkPage($pagename,$imap,$path,$title,$txt,$fmt);
    
    if ( TRUE === strpos($targetLink, "action=browse") ){
    	# Could be static page as action will equal browse
    } else if ( FALSE === strpos($targetLink, "action=")){
    	# Could be static page as action will equal browse
    } else{
    	# Not a static page
    	return $targetLink;
    }
    
    $targetPageName = getLinkTargetPageName($pagename, $path);
    
    if (!isPossibleStaticPage($targetPageName)){
	    # A Static Page
    	@removeStaticPage($targetPageName, $ApplicationPathDir);
    	return $targetLink; 
    }
    
    $theStaticPageLink = getStaticPageLink($targetPageName, $targetLink, $StaticPagePath);        
    
    # This is a static page, automatically create it otherwise it will be a dead link
    $wikiLinkStaticPageDir = $ApplicationPathDir . "/" .
    	$StaticPageDir . "/" . getStaticPageName($targetPageName);
    
    if (!file_exists($wikiLinkStaticPageDir)){
    	global $StaticPageDeadLinks;
    	array_push($StaticPageDeadLinks, $targetPageName);
    }
    
    return $theStaticPageLink;
    
}

function getStaticPageLink($targetPageName, $targetLink, $StaticPagePath){
	
	if (!isPossibleStaticPage($targetPageName)){
		return FALSE;
	}
    
    $hrefToken = "'";
    $hrefStart = strpos($targetLink, "'", strpos($targetLink, "href"));    
    $hrefStop = strpos($targetLink, "'", $hrefStart + 1);
    $hrefText = substr($targetLink, $hrefStart + 1, $hrefStop - $hrefStart - 1);
    
    // Static pages will have only one argument in the form of $PageUrl
    // See pmwiki.php $PageUrl = 'PUE(($EnablePathInfo) ? "$ScriptUrl/$group/$name" : "$ScriptUrl?n=$group.$name")'
    // with optional "action=browse" and "action=print"
    $hrefParts = preg_split("/[?]/", $hrefText);  // $args[0] is html link, $args[>0] is the arguments
    
    $arguments = $hrefParts[1];
    
    if ( strpos("action=", $arguments) !== FALSE
    		&& strpos("action=browse", $arguments) === FALSE){
    	
    	return FALSE;
    }
    
    $targetStaticLink =  $StaticPagePath . "/"
        	. getStaticPageName($targetPageName);
        
    $targetLink = substr_replace($targetLink, $targetStaticLink, $hrefStart + 1, $hrefStop - $hrefStart - 1);
    	
    return $targetLink;
    
}

# When a wiki page is saved, does it update the corresponding static page
function UpdateStaticPage($pagename,&$page,&$new){
	global $IsPagePosted, $ApplicationPathDir;
	
	if ($IsPagePosted){
		createStaticPage($pagename, $ApplicationPathDir);
	}
	
	# $pagename should be in the form of "Main.HomePage"
	$pagenameGroup = substr($pagename, 0, strpos($pagename, "."));
    $pagenamePage = substr($pagename, strpos($pagename, ".") + 1, strlen($pagename) - 1);
	
	global $StaticPageSaveActionPageList;
    if (isset($StaticPageSaveActionPageList) && is_array($StaticPageSaveActionPageList)){
    	for ($index = 0; $index < sizeof($StaticPageSaveActionPageList); $index++) {
			$currentValue = $StaticPageSaveActionPageList[$index];
			
			$currentGroup = substr($currentValue, 0, strpos($currentValue, "."));
    		$currentPage = substr($currentValue, strpos($currentValue, ".") + 1, strlen($currentValue) - 1);
    		
    		# Group is a special keyword that is replaced with the group of the page being saved
    		if ($currentGroup == "Group"){
    			$currentValue = $pagenameGroup . "." . $currentPage;
    		}
    		
			createStaticPage($currentValue, $ApplicationPathDir);
		}    	
    }
    
}

# When pmwiki.php?action=$StaticPageGeneratorActionName
function HandleStaticPageGenerator($pagename, $auth = 'admin') {
	
	$page = RetrieveAuthPage($pagename, $auth, true);
  	if (!$page) { Abort("?unable to do action"); }
	
	include("StaticPageGenerator.php");
}

# When pmwiki.php?action=browse
function HandleBrowseToPossibleStaticPage($pagename, $auth = 'read'){
	
	global $StaticPageDir;
	# Let Wiki links point to static pages
	if (isset($StaticPageDir)){
		
		global $LinkFunctions, $LinkFunctionsIntercepted;
		$LinkFunctionsIntercepted = array();
		foreach($LinkFunctions as $key => $value) { 
			$LinkFunctionsIntercepted[$key] = $value;
			$LinkFunctions[$key] = 'LinkFromPossibleStaticPage';
		}
		
	    $LinkFunctions['<:page>'] = 'LinkToPossibleStaticPage';
	}

	HandleBrowse($pagename, $auth);
	
	global $action;
	if ($action == "browse"){
		global $StaticPageDeadLinks, $ApplicationPathDir;
		$StaticPageDeadLinks = array_values(array_unique($StaticPageDeadLinks));
		
		for ($index = 0; $index < sizeof($StaticPageDeadLinks); $index++) {
			
			createStaticPage($StaticPageDeadLinks[$index], $ApplicationPathDir);
		}
	}
	
}

# When pmwiki.php?action=browseStaticPage
function HandleBrowseStaticPage($pagename, $auth = 'admin') {
	global $HandleActions, $HandleAuth;
	$HandleActions["browse"]($pagename, $HandleAuth["browse"]);
}

function getStaticPageName($pagename){
    # $wikiLink is in the form of "Main.HomePage"
    
    if (strlen($pagename) < 3 || strpos($pagename, ".") === FALSE){
    	return "Main_HomePage.html";  # Default if not specified
    }
    
    $wikiLinkGroupName = substr($pagename, 0, strpos($pagename, "."));
    $wikiLinkPageName = substr($pagename, strpos($pagename, ".") + 1, strlen($pagename) - 1);
    
    return $wikiLinkGroupName . "_" .$wikiLinkPageName .".html";
}


function createStaticPage($wikiLink, $wikiDir = "."){
   	
   	# $wikiLink is in the form of "Main.HomePage"
   	
   	$isStaticPageLink = isPossibleStaticPage($wikiLink);
   	
   	if (!$isStaticPageLink){
    	@removeStaticPage($wikiLink, $wikiDir);
    	return FALSE;
    }
   	
    global $ScriptUrlRemoteAddress, $StaticPageDir, $StaticPageBrowseActionName;
    	
    $wikiLinkAddress = $ScriptUrlRemoteAddress . "?n=" . $wikiLink . "&action=$StaticPageBrowseActionName";   
    
    $wikiLinkStaticPageDir = $wikiDir . "/" .
    	$StaticPageDir . "/" . getStaticPageName($wikiLink);

    if (! ($wikiLinkPageContents = file_get_contents($wikiLinkAddress)) ){
    	echo "Could not open URL for copying:  " .  $wikiLinkAddress;
    	return FALSE;
    }
    
	
	ensureStaticPageDirExists();
	    
    if (!($fpStaticPage = fopen($wikiLinkStaticPageDir , "w+"))){
       echo "Could not open file for writing:  " .  $wikiLinkStaticPageDir;
       return FALSE;
    }
    
    if (!(fwrite($fpStaticPage, $wikiLinkPageContents))){
       echo "Could not write to file:  " .  $wikiLinkStaticPageDir;
       return FALSE;
    }
    
    fclose($fpStaticPage);
    
    return TRUE;
    
}

function removeStaticPage($wikiLink, $wikiDir = "."){
	global $StaticPageDir;
	
	if (isset($wikiLink) && strlen($wikiLink) > 1 && !(substr($wikiLink, 0, 1) == ".")){
		return unlink($wikiDir . "/" . 
			$StaticPageDir . "/" . getStaticPageName($wikiLink));  
	}
	
	return FALSE;
}



function isPossibleStaticPage($pagename){
		
	# $pagename in the form of "Main.HomePage"
	
	# Standard Text match Exclude - Note to deprecate
    global $StaticPageExclude;
    if (isset($StaticPageExclude) && is_array($StaticPageExclude) 
    		&& in_array($pagename, $StaticPageExclude)){
    	// Remove Static Page if it exists
    	return FALSE;
    }
    
    # Regular Expression Exclude
    global $StaticPageRegularExpressionExclude;
    if (isset($StaticPageRegularExpressionExclude) && is_array($StaticPageRegularExpressionExclude)){
    	for ($index = 0; $index < sizeof($StaticPageRegularExpressionExclude); $index++) {
			$currentValue = $StaticPageRegularExpressionExclude[$index];
			if (preg_match($StaticPageRegularExpressionExclude[$index], $pagename) > 0){
				return FALSE;
			}
		}    	
    }
    
    # Not part of the exclude list
    return TRUE;
    
}

function ensureStaticPageDirExists(){
	
	global $ApplicationPathDir, $StaticPageDir;
	
	$outputDir = $ApplicationPathDir . "/" . $StaticPageDir;
	
	if (!is_dir($outputDir)){
    	
    	# Permissions - Global Read and Write Access, No Execute
    	if (!MakeDirectoryPath($outputDir, 0006)){
    		echo "Could not create output directory for static files:  " .  $outputDir;
       		exit;
    	}
    }
}

function MakeDirectoryPath($path, $mode = 0755){
	
	# Attempt to create $dir directory
	if (is_dir($path) || @mkdir($path,$mode)){
		return TRUE;
	}
	# Attempt to create parent directory
	if (!MakeDirectoryPath(dirname($path),$mode)){
		return FALSE;
	}
	
	# Attempt again to create this directory
	return @mkdir($path,$mode);
}

function getLinkTargetPageName($pagename, $path){
	global $QueryFragPattern;
    
    if (!preg_match("/^\\s*([^#?]+)($QueryFragPattern)?$/", $path, $match)){
    	return "";	
    }
    
    $targetPageName = MakePageName($pagename, $match[1]); 
    if (!$targetPageName){
    	return "";
    }else{
    	return $targetPageName;
    }
}
?>